#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>
#include <fstream>

using namespace std;

/* ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ==== ====  
 La idea de esta libreria es hacer un gestor de logs para poder usar en muchos programas.
 Los fundamentos de este gestor de logs son que con la menor dificultad posible se gestione las salidas de error, logs importantes o salidas secundarias. Ambas se guardaran con marcadores diferentes para diferenciarlas claramente. 
 v1.0 --> Funciones basicas.
 - Guardado de los diferentes mensajes
 - Escritura de fecha y hora
 - No se sobreescriben, se guardan los mensajes antiguos
 v2.0 --> 
 - Poder seleccionar idioma 
 - Colorear los mensajes segun su tipo
 - Envo de los logs por mail
 - Acumulacion de logs en un servidor 
 */

// ---------------------------------------------------------
// 		METODOS DE TRATMIENTOS DE CARACTERES
// ---------------------------------------------------------

// Convertir integer en string
string itos(int i)
{      
       //   int to string en c++
       string num;
       int temp;
       while(i / 10!=0)
       {
         temp=i%10;
         i= i/10;
         temp =temp + 48;
         num = (char)temp + num;

       }
       i=i+48;
       num = (char)i + num ;
       
       return num;
}

// Conseguir la fecha del da actual para crear/modificar ficheros de log
string fecha_fichero()
{
	string nombre;
	time_t fecha;
	struct tm *temp;
	struct tm fecha_tm;
	
	/* obtener fecha (time_t) */
	/* obtener fecha (time_t) */
	if ((fecha = time(NULL)) == (time_t) -1)
		exit;
	
	/* obtener fecha (struct tm) */
	temp = localtime(&fecha);
	memcpy(&fecha_tm, temp, sizeof fecha_tm);
	
	nombre+=itos(fecha_tm.tm_mday);
	nombre+=itos(fecha_tm.tm_mon+1);
	nombre+=itos(fecha_tm.tm_year + 1900);
	nombre+=".lg";
	
	return	nombre;
}

// Saber la hora para escribir en cada mensaje
string dar_hora()
{
	string hora;
	time_t fecha;
	struct tm *temp;
	struct tm fecha_tm;
	
	/* obtener fecha (time_t) */
	/* obtener fecha (time_t) */
	if ((fecha = time(NULL)) == (time_t) -1)
		exit;
	
	/* obtener fecha (struct tm) */
	temp = localtime(&fecha);
	memcpy(&fecha_tm, temp, sizeof fecha_tm);
	
	hora+=itos(fecha_tm.tm_hour);
	hora+=":";
	hora+=itos(fecha_tm.tm_min);
	hora+=":";
	hora+=itos(fecha_tm.tm_sec);
	hora+=" --> ";
	
	return	hora;
}

bool copiar_fichero(string origen, ofstream& fout)
{
	ifstream fin;
	
	fin.open(origen.c_str());
	
	if (fin.fail())
	{
		cout << "Fichero de origen no existe.\n";
		return false;
    	}
	
	 char c = fin.get();
	 while (!fin.eof())
	 {
	 	 fout << c;
	 	 c = fin.get();
	 }

	 fin.close();
     

	 cout << "\n Done. \n";
	 return true;	
}

bool copia_selectiva(string origen, ofstream& fout)
{
	ifstream fin;
	bool flag=false;
	char c_ant;
	
	fin.open(origen.c_str());
	
	if (fin.fail())
	{
		cout << "Fichero de origen no existe.\n";
		return false;
    	}
	
	 char c = fin.get();
	 while (!fin.eof())
	 {
	 	 if(c==':')
	 	 	 flag=true;
	 	 if(c=='\n')
	 	 {
	 	 	 flag=false;
	 	 	 fout << ", ";
	 	 }
	 	 if(flag)
	 	 	 if (c!=':')		// 
	 	 	 	fout << c;
	 	 c_ant=c;	
	 	 c = fin.get();
     }

     fin.close();
     
     cout << "\nDone.\n";
     
     return true;	
}
// --------------------------------------------
// FIN METODO DE TRATAMIENTO DE CARACTERES.
// --------------------------------------------

// ------------------------------------------------------------
// INICIO PROCEDIMEINTOS PARA OBTENER INFORMACION DEL SISTEMA
// ------------------------------------------------------------
void borrar_fichero_temporal()
{
	//Borrar fichero temporal
	if( remove( "temp.txt" ) == -1 )
		perror( " Error borrando el fichero !!" );
	else
		puts( "Fichero borrado correctamente." );
}

// ------------------------------------------------------------
// FIN PROCEDIMEINTOS PARA OBTENER INFORMACION DEL SISTEMA
// ------------------------------------------------------------

// ------------------------------------------------------------
// Procedimientos PRINCIPALES  <----
// ------------------------------------------------------------

// Crear fichero o escribir sobre el fichero existente.
// Orden de escritura LIFO
void crear_fichero_log()
{
	ifstream fin;
	string nombre_fichero;
	
	nombre_fichero=fecha_fichero();
	
	fin.open(nombre_fichero.c_str());
	
	if (fin.fail())
	{
		cout << "Fichero de origen no existe.\n";
		ofstream fout;
		fout.open(nombre_fichero.c_str());
		cout << "Fichero creado.\n";
		fout.close();
    	}
    	else
    	{
    		fin.close();
    		
    		FILE *fich;
    		
    		fich=fopen(nombre_fichero.c_str(),"a+"); 
    		rewind(fich); 
    		fprintf(fich,"\n");    		
    		fclose(fich);
    	}
}

// Escribir el mensaje en el fichero de log
void escribir_log(int tipo, string mensaje)
{
	ofstream fout;
	string fichero;
	string error=" [ERROR] ";
	string menssage="  [MENSAJE] ";
	string resultado="[SOLUCION] ";
	string otro=" [OTRO] ";
	string mensaje_final;
	
	fichero=fecha_fichero();
	mensaje_final=dar_hora();
	
	//Abrimos el fichero para escritura
	fout.open(fichero.c_str(), ios_base::app); // Abrimos el fichero de destino
	
	//Escribimos el mensaje del log segun su tipo
	switch(tipo)
	{
		case 1: mensaje_final+=error;			
		case 2: mensaje_final+=menssage;
		case 3: mensaje_final+=resultado;
		default: mensaje_final+=otro;
	}	
	
	mensaje_final+= " ";
	mensaje_final+=mensaje;
	mensaje_final+="\n";
	
	fout << endl << mensaje_final << endl;
	fout.close(); // Cerramos el fichero de destino
}

// Metodo principal para la ejecucin del mtodo
void logs(string cadena, int tipo)
{

	/* Pasos a seguir para los logs del sistema:
	1.- Primero saber el nombre del programa que se esta ejecutando
	2.- Segundo, crear el fichero donde se escribiran los logs de ese programa
	3.- Tercero, escribir los logs en el fichero. */
	// string nombre=busqueda_programa();
	crear_fichero_log();
	escribir_log(tipo, cadena);
}
// TERMINADO, FALTA VALIDAR.